-- The main function is the first function called from Iguana.
-- The Data argument will contain the message to be processed.
require 'stringutil'

local function trace(a,b,c,d) return end


function main(Data)
 
   -- Process batch file
   -- convert non-conformant terminators to "\r"
   Data = convertTerminators(Data)
   
   -- split batch into array of messages
   local Msgs=splitBatch(Data)
   
   -- populated flag controls the logic that enters
   -- payer and provider information one time into the
   -- respective transaction header envelope
   local populated=false
   local msgCounter = 1
   
   local x12Message = require 'x12_mapfactory'
   local Outx12Msg = x12Message.create('4010-270')

   for i=1,#Msgs do
      local OutHL7, name = hl7.parse{vmd='BARHL7.vmd', data= Msgs[i]}
      -- On first pass create the x12 doc and populate
      -- transactional header with payer and provider information
      if populated == false then 
         Outx12Msg = x12Message.populatePP(Outx12Msg,OutHL7)
         populated=true
      end
      
      Outx12Msg=x12Message.populateSubscr(Outx12Msg,OutHL7,msgCounter)
      msgCounter = msgCounter + 1
     
   end
   local Out = Outx12Msg:S()
   Out = Out:gsub("|","*")
         
end



function splitBatch(Data)
   
   -- strip batch info off Data
   local a = Data:split('\r')  
   trace(a)
   Data=a[1]
   trace(Data)
   for i=2,#a do
      Data=Data..'\r'..a[i]
      trace(Data)
   end
   trace(Data)
   
   -- split Data into messages
   local delimiter='MSH|^~\\&|'
   local b=Data:split(delimiter)

   -- add MSH segment info
   trace(b)
   for i=1,#b do 
      b[i-1]=delimiter..b[i]
   end
   b[#b]=nil -- delete dup msg
   trace(b)
   
   -- SOME IDEAS THAT COULD BE USEFUL

   -- global variable to count messages
   MsgCnt = #b
   trace('Messages Count '..MsgCnt)
   
   -- globals for batch segment info
   FHS=a[1]:split('|')
   BHS=a[2]:split('|')
   FTS=a[#a]:split('|') 
   BTS=a[#a-1]:split('|') 
   
   return b
end


function processMsg(Msg)
   local msg, name = hl7.parse{vmd='BARHL7.vmd', data= Msg}  
   return msg
end


function convertTerminators(Data)
   Data = Data:gsub('\r\n','\r')
   return Data:gsub('\n','\r')
end


